#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <stdlib.h>
#include <string.h>


/*
 * Returns: u_char *         the url-encoded string
 * Parameters:
 *   - const u_char *str     the string to encode
 *   - long len            the length of the string
 *
 * This function url-encodes a string
 *
 */
u_char *cf_cgi_url_encode(const u_char *str,size_t len) {
  long nlen = 3 * len + 1; /* new string can max 3x longer than old string (plus 0-byte) */
  u_char *nstr = malloc (nlen+1);
  register u_char *ptr1,*ptr2;

  bzero (nstr, nlen+1);

  for(ptr1=(u_char *)str,ptr2=nstr;*ptr1;ptr2++,ptr1++) {
    if((*ptr1 >= 48 && *ptr1 <= 122) || (*ptr1 == '_' || *ptr1 == '.' || *ptr1 == '-')) {
      *ptr2 = *ptr1;
    }
    else {
      sprintf(ptr2,"%%%02X",(int)*ptr1);
      ptr2 += 2;
    }
  }

  *ptr2 = '\0';
  return nstr;
}


int encodeurl_main (int argc, char * argv[])
{
  char * enc ; 
  if (argc != 2 ) {
    printf("Usage : encodeurl \"string\" \n");
    return 127 ; 
  }
  enc = cf_cgi_url_encode (argv[1],strlen (argv[1]));
  printf("%s\n",enc);
  free (enc);
  return 0;
}
